local M = {}

require "socket"

local startTime = 0
local diffTime = 0
local endTime = 0
local carConfig = ""
local hh = 0
local mm = 0
local ss = 0
local ms = 0
local running = false
local all = {}
local json_data = jsonEncode(all)


local function convert_to_time(milliseconds)
    --hh = (milliseconds / (60 * 60 * 1000)) % 24
    mm = (milliseconds / (60 * 1000)) % 60
    ss = (milliseconds / 1000) % 60
    ms = milliseconds % 1000
    return string.format("%02d:%02d.%03d", mm, ss, ms)
end

local function onBeamNGTrigger(data)
    if data.triggerName == 'BeamNGTrigger_1' and data.event == 'enter' then
        --print('subjectName: ' .. data.subjectName .. ' - playerInstance: ')
        running = true
        carConfig = be:getPlayerVehicle(0):getField('partConfig', '')
        all.carConfig = carConfig
        --guihooks.message('Timer startet - Car config: ' .. carConfig, 5)
        --print('Timer startet! - Car config: ' .. carConfig)
        startTime = socket.gettime()*1000
    end
    if data.triggerName == 'BeamNGTrigger_2' and data.event == 'enter' then
        --carConfig = be:getPlayerVehicle(0):getField('partConfig', '')
        --diffTime = socket.gettime()*1000 - startTime
        --endTime = convert_to_time(diffTime)
        --all.lapTime = diffTime
        --all.endTime = endTime
        --all.carConfig = carConfig
        --json_data = jsonEncode(all)
        guihooks.trigger('sendTimer', json_data)
        guihooks.message('Lap time: ' .. endTime .. ' - Car config: ' .. carConfig, 10)
        running = false
        --print('Lap time: ' .. endTime .. ' - Car config: ' .. carConfig)
    end
end

local function onTimerSend()
    
end

local function onResetGameplay(playerID)
    running = false
end

local function onUpdate()

    if running then
        diffTime = socket.gettime()*1000 - startTime
        endTime = convert_to_time(diffTime)
        all.lapTime = diffTime
        all.endTime = endTime     
        json_data = jsonEncode(all)
        guihooks.trigger('showTimer', json_data)
        --print(convert_to_time(diffTime))
        --guihooks.message('Lap time: ' .. convert_to_time(diffTime), 0)
    end
    
	--all.endTime = endTime
	--guihooks.trigger('sendAllState', all)
    --print('All: ' .. all.endTime)
	--return all.endTime
    --print(diffTime)
end

M.convert_to_time = convert_to_time
M.onBeamNGTrigger = onBeamNGTrigger
M.onTimerSend = onTimerSend
M.onResetGameplay = onResetGameplay
M.onUpdate = onUpdate

return M